class Company {
  private int rank;
  private String name;
  private int revenue;
  private int profit;
  
  private Company() { }
  
  public static Company readCompany() {
    Company c = new Company();
    c.rank = readNumber();
    if (!In.done()) {
      return null;
    }
    c.name = readText();
    c.revenue = readNumber();
    c.profit = readNumber();
    return c;
  }

  public int getRank() { return rank; }
  public String getName() { return name; }
  public int getRevenue() { return revenue; }
  public int getProfit() { return profit; }
  
  private static int readNumber() {
    int n = In.readInt();
    if(In.peek() == ';') {
      In.read();
    }
    return n;
  }
  
  private static String readText() {
    StringBuilder b = new StringBuilder();
    char ch = In.read();
    while(ch != ';') {
      b.append(ch);
      ch = In.read();
    }
    return b.toString();
  }
  
  public String toString() {
    return(String.format("%3d. %-40s %10d %10d", 
      rank, name, revenue, profit));
  }
  
  public int hashCode() {
    return rank * name.hashCode();
  }
}